/*!
// @file		EmaiTypes.h
//
// @brief		General types declaration
//
// @version		Mailit for C/C++ 1.0
//
// @author		(C) 2008 Dacons LLP.
//
// @bug			If you have problems or suggestions, please contact
//				the Online Support at: http://www.mailitcomponents.com/support
*/

#ifndef __EMAITYPES_H__
#define __EMAITYPES_H__

#ifdef __cplusplus
	extern "C" {
#endif

/*!
// @brief	EmaiEnumNullOptions
*/
enum EmaiEnumNullOptions
{
	EmaiNullOptions							= 0
};

/*!
// @brief	EmaiEnumStructureVersion
*/
enum EmaiEnumStructureVersion
{
	EmaiStructureVersionFirst				= 1,
	EmaiStructureVersionCurrent				= EmaiStructureVersionFirst
};

#if defined(WIN32)

#define EMAIAPI(_type)						_type __cdecl
#define EMAICALLBACKAPI(_type, _name)		_type (__cdecl *_name)
typedef wchar_t								EmaiUniChar;
typedef UINT32								EmaiUint32;
typedef INT32								EmaiSint32;

#elif defined(__MWERKS__)

#define EMAIAPI(_type)						extern _type
#define EMAICALLBACKAPI(_type, _name)		_type (*_name)
typedef UniChar								EmaiUniChar;
typedef UInt32								EmaiUint32;
typedef SInt32								EmaiSint32;

#elif defined(__GNUC__)

#define EMAIAPI(_type)						__attribute__((visibility("default"))) _type
#define EMAICALLBACKAPI(_type, _name)		_type (*_name)
typedef UniChar								EmaiUniChar;
typedef UInt32								EmaiUint32;
typedef SInt32								EmaiSint32;

#else

#error ("Unknown platform")

#endif

typedef EmaiUint32							EmaiOptions;
typedef const EmaiUniChar*					EmaiConstUniCharPtr;
typedef EmaiUniChar*						EmaiUniCharPtr;
typedef const char*							EmaiConstCharPtr;
typedef char*								EmaiCharPtr;
typedef char								EmaiChar;

#ifdef __cplusplus
	}
#endif

#endif /*__EMAITYPES_H__*/
